
package ro.cnlr.polymorphism;

import ro.cnlr.polymorphism.humans.Woman;
import java.util.Scanner;
import ro.cnlr.polymorphism.animals.*;
import ro.cnlr.polymorphism.humans.Human;
import ro.cnlr.polymorphism.humans.Man;

/*
   Polimorfism
conditii:
- o ierarhie de clase
- cel putin o metoda din superclasa
  sa fie redefinite (overridded) 
  in subclase

    Obiectele care redefinesc cel putin 
    o metoda din superclasa se 
    numesc OBIECTE (INSTANTE) POLIMORFICE
*/


public class TestPolymorphism2 {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        Being being = null; // referinta la interfata
      
        char op; // operatia
        do
        {
            System.out.println("H - Human");
            System.out.println("M - Man");
            System.out.println("W - Woman");
            System.out.println("A - Animal");
            System.out.println("C - Cat");
            System.out.println("D - Dog");
            System.out.println("X - Exit");
            op = scanner.next().charAt(0);
            
            switch(op) {
     
                case 'H':
                case 'h': 
                    being = new Human();
                    break;
                case 'M':
                case 'm': 
                    being = new Man();
                    break;
                case 'W':
                case 'w': 
                    being = new Woman();
                    break;
                case 'A':
                case 'a': 
                    being = new Animal();
                    break;
                case 'C':
                case 'c': 
                    being = new Cat();
                    break;
                case 'D':
                case 'd': 
                    being = new Dog();
                    break;
                case 'X':
                case 'x': 
                    System.out.println("Bye!");
                    break;
                default: System.out.println("Command not found!");
            }
            
            if (being != null) {
                being.eat(); // eat() metoda cu comportament polimorfic
                being = null;
            }
            
        } while (op != 'x' && op != 'X');
        
    }
}
